/* 10/10/06 - Predrag messed with part d) plot log (x-x^*) */
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

double f (double, double);
double ftr (double, double, int);

void parta(void);
void partb(void);
void partX(double, char);
void partd(void);
void partf(void);
void partg(void);
void parth(void);

int menu(void);
int chkmen(int, char *);

void main (void) {
   double x, l;
   int n = 100, ntr = 1e4;
   int mch;

   do {
      fflush(stdin);

      mch = menu();

      switch (mch) {
         case 'a':
            parta(); /*Done*/
            break;
         case 'b':
            partb();
            break;
         case 'd':
            partd();
            break;
         case 'f':
            partf();
            break;
         case 'g':
            partg();
            break;
         case 'h':
            parth();
            break;
         case 'z':
            printf("Farewell!\n");
      }
   } while (mch != 'z');
}

double f (double x, double l) {
   return l - x * x;
}

double ftr (double x0, double l, int n) {
   int i;
   double x;

   x = x0;

   for (i = 0; i < n; i++) x = f(x, l);

   return x;
}

int chkmen (int c, char * options) {
   int i;
   int ctmp;

   ctmp = tolower(c);

   for (i = 0; i < strlen(options); i++)
      if (options[i] == ctmp) return 1;

   return 0;
}

int menu (void) {
   int c;
   char * opts = "abdfghz";
   
   do {
      printf ("===============================================================\n"
              "a) Choose lambda and x0 and accuracy, find x*.\n"
              "b) Choose lambda range and change, transient, n.\n"
	      "d) Plot for lambda = 3/4.\n"
	      "f) Plot for lambda = 1, 1.310..., 1.381..., 1.397...\n"
              "g) Find delta and alpha for bifurcations (slow) (NOT WORKING)\n"
              "h) Compute Feigenbaum delta and alpha scaling factor (needs g) (NOT WORKING).\n"
              "===============================================================\n"
	      "z) Exit\n"
              "===============================================================\n"
	     );
      c=getc(stdin);
      while(getc(stdin) != '\n');
   } while (!chkmen(c, opts));

   c = tolower(c);
   return c;
}

void parta(void) {
   double l, x0;
   int acc, i, j;
   double x[512] = {0.0};
   FILE * fptr;

   do {   
      printf("Enter lambda, x0, accuracy (10^-n) < f.fff, f.fff, n >\n");
      scanf("%lf, %lf, %d", &l, &x0, &acc);
      while(getc(stdin) != '\n');
   } while (l < 0 || x0 < -1 || x0 > 1 || acc > 8 || acc < 1);

   printf ("Lambda: %lf, x0 = %lf, desired accuracy = 10^-%d\n", l, x0, acc);

   x[0] = x0;
   x[1] = f(x[0],l);
   i = 2;

   do {
      x[i] = f(x[i-1], l);
      i++;
   } while (i < 512 && !(fabs(x[i-1] - x[i-2]) < pow(10.0,-(double)acc) && fabs(x[i-1] - x[i-2]) < fabs(x[i-2] - x[i-3])));

   fptr = fopen("ppdtmp.dat", "w");
   j = 1;
   while (j < i) {
      fprintf (fptr, "%d\t%.8lf\t%.8lf\n", j-1, x[j-1], x[j-1]);
      fprintf (fptr, "%d\t%.8lf\t%.8lf\n", j-1, x[j-1], x[j]);
      j++;
   }
   fclose(fptr);

   fptr = fopen("ppdgnuplot.tmp", "w");
   fprintf(fptr, /*"set terminal postscript\n"
                 "set output \"ppdtmpa.ps\"\n"*/
                 "set title \"xn+1 vs xn for small lambda\\nl:%.4lf, x0:%.4lf, acc:10^-%d\"\n"
                 "set multiplot\n"
                 "set size ratio -1\n"
                 "l=%lf\n"
                 "xmin=-0.5*(1+sqrt(1+4*l))\n"
                 "xmax=-xmin\n"
                 "ymin=-2.0\n"
                 "ymax= 2.0\n"
                 "f(x)=l-x**2\n"
                 "plot [x=xmin:xmax][ymin:ymax] f(x) notitle\n"
                 "plot [x=xmin:xmax][ymin:ymax] x w l notitle\n"
                 "plot [xmin:xmax]  [ymin:ymax] \"ppdtmp.dat\" u 2:3 w l lt 3\n"
                 "unset multiplot\n",
                 l, x0, acc,
                 l);
   fclose(fptr);

   system("gnuplot -persist < ppdgnuplot.tmp");
//   system("convert -rotate 90 ppdtmpa.ps ppdtmpa.jpg");
//   system("rm ppdgnuplot.tmp;rm ppdtmp.dat;rm ppdtmpa.ps");
}

void partb(void) {
   double lmin, lmax, l;
   int tr, n, i, j;
   double x[2] = {0.0}, xmin, xmax;
   FILE * fptr;

   do {   
      printf("Enter lambda min, lambda max, 2^trans, 2^n, xmin, xmax < f.fff, f.fff, n, n, f.fff, f.fff >\n");
      scanf("%lf, %lf, %d, %d, %lf, %lf", &lmin, &lmax, &tr, &n, &xmin, &xmax);
      while(getc(stdin) != '\n');
   } while (lmin < 0.0 || lmax > 2.0 || lmin > lmax || tr < 0 || n < 0 || xmin < -2.001 || xmax > 2.001 || xmin > xmax);

   if (tr > 15) tr = 15;
   if (n > 14) n = 14;

   printf ("Lambda: [%lf,%lf], transient = 2^%d, points = 2^%d\n", lmin, lmax, tr, n);

   tr = (int) pow(2, tr);
   n = (int) pow (2, n);

   x[0] = 0.5;
   l = lmin;

   fptr = fopen("ppdtmp.dat", "w");

   for (i = 0; i < n; i++) {
      x[0] = ftr(x[0], l, tr);

      for (j = 0; j < n; j++) {
         x[0] = f(x[0], l);
         fprintf(fptr, "%.8lf\t%.8lf\n", l, x[0]);
      }
      l += (lmax - lmin)/(double) n;
   }
   fclose(fptr);

   fptr = fopen("ppdgnuplot.tmp", "w");
   fprintf(fptr, /*"set terminal postscript\n"
                 "set output \"ppdtmpb.ps\"\n"*/
                 "set title \"Bifurcation diagram lambda [%.4lf,%.4lf]\"\n"
                 "plot [ ][%lf:%lf] \"ppdtmp.dat\" u 1:2 w dots\n",
                 lmin, lmax, xmin, xmax);
   fclose(fptr);

   system("gnuplot -persist < ppdgnuplot.tmp");
//   system("convert -rotate 90 ppdtmpb.ps ppdtmpb.jpg");
//   system("rm ppdgnuplot.tmp;rm ppdtmp.dat;rm ppdtmpa.ps");
}

/* prints parts d), e) */
void partX(double lambda, char c) {
   double l, x0;
   int acc, i, j, n;
   double x[1024*256] = {0.0};
   FILE * fptr;
   char name[2][12] = {"ppdtmpX.ps", "ppdtmpX.jpg"}, instr[2048] = {'\0'};

   name[0][6] = c;
   name[1][6] = c;
   do {   
      printf("Enter x0, accuracy (10^-n), 2^iterations < f.fff, n, n >\n");
      scanf("%lf, %d, %d", &x0, &acc, &n);
      while(getc(stdin) != '\n');
   } while (x0 < -1 || x0 > 1 || acc > 8 || acc < 1 || n < 0);

   if (n > 20) n = 20;
   l = lambda;

   printf ("Lambda: %lf, x0 = %lf, desired accuracy = 10^-%d, iter=2^%d\n", l, x0, acc, n);

   n = (int) pow(2, n);

   x[0] = x0;
   x[1] = f(x[0],l);
   i = 2;

   do {
      x[i] = f(x[i-1], l);
      i++;
   } while (i < n && i < 1024*256 && !(fabs(x[i-1] - x[i-2]) < pow(10.0,-(double)acc) && fabs(x[i-1] - x[i-2]) < fabs(x[i-2] - x[i-3])));

   fptr = fopen("ppdtmp.dat", "w");
   j = 1;
   while (j < i) {
      fprintf (fptr, "%d\t%.8lf\t%.8lf\t%.8lf\n", j-1, x[j-1], x[j-1],log(fabs(x[j-1]-.5)));
      fprintf (fptr, "%d\t%.8lf\t%.8lf\t%.8lf\n", j-1, x[j-1], x[j],log(fabs(x[j-1]-.5)));

      j++;
   }
   fclose(fptr);

/* prints part d), f^n as function of n */
   fptr = fopen("ppdgnuplot.tmp", "w");
   fprintf(fptr, /*"set terminal postscript\n"
                 "set output \"ppdtmpd.ps\"\n"*/
                 "set title \"f^n(x0) for \\nlambda:%.4lf, x0:%.4lf, acc:10^-%d\"\n"
/* plot log (x-x^*)/time: */
		 "set logscale x\n"
                 "plot [][] \"ppdtmp.dat\" u 1:4 w d\n"
		 "unset logscale x\n",
                 l, x0, acc);
/* set x range manually: 
		 "plot [][0.3:0.7] \"ppdtmp.dat\" u 1:2 w d\n",
                 l, x0, acc);
*/
   fclose(fptr);

   sprintf (instr, "gnuplot -rotate 90 %s %s", name[0], name[1]);

   system("gnuplot -persist < ppdgnuplot.tmp");

   fptr = fopen("ppdgnuplot.tmp", "w");
   fprintf(fptr, /*"set terminal postscript\n"
                 "set output \"ppdtmpa.ps\"\n"*/
                 "set title \"xn+1 vs xn for\\nl:%.4lf, x0:%.4lf, acc:10^-%d\"\n"
                 "set multiplot\n"
                 "set size ratio -1\n"
                 "l=%lf\n"
                 "xmin=-0.5*(1+sqrt(1+4*l))\n"
                 "xmax=-xmin\n"
                 "ymin=-2.0\n"
                 "ymax= 2.0\n"
                 "f(x)=l-x**2\n"
                 "plot [x=xmin:xmax][ymin:ymax] f(x) notitle\n"
                 "plot [x=xmin:xmax][ymin:ymax] x w l notitle\n"
                 "plot [xmin:xmax]  [ymin:ymax] \"ppdtmp.dat\" u 2:3 w l lt 3\n"                 "unset multiplot\n",
                 l, x0, acc,
                 l);
   fclose(fptr);

   system("gnuplot -persist < ppdgnuplot.tmp");


//   system(instr);
//   system("rm ppdgnuplot.tmp;rm ppdtmp.dat;rm ppdtmpa.ps");
}

void partd(void) {
   partX(0.75, 'd');
}

void partf(void) {
   printf("Running for lambda = 1.0\n");
   partX(1.0, '1');
   printf("Press a key ...");
   getchar();
   printf("Runnin for lambda = 1.31070274134\n");
   partX(1.31070274134, '2');
   printf("Press a key ...");
   getchar();
   printf("Runnin for lambda = 1.38154748443\n");
   partX(1.38154748443, '3');
   printf("Press a key ...");
   getchar();
   printf("Runnin for lambda = 1.3979453597\n");
   partX(1.3979453597, '4');
   printf("Press a key ...");
   getchar();
}

void partg(void) {
   double lmin, lmax, l, facc, dl;
   int acc, n, npd, tr, i, j, k, p, flag;
   double x[128] = {0.0}, xtmp, xmin, xmax;
   FILE * fptr;

   do {   
      printf("Enter desired 10^-accuracy, number of p. doublings, 2^transient, 2^points < n, n, n, n >\n");
      scanf("%d, %d, %d, %d", &acc, &npd, &n, &tr);
      while(getc(stdin) != '\n');
   } while (n <= 0 || acc < 1 || npd <= 0 || tr < 1);

   if (tr > 15) tr = 15;
   if (n > 20) n = 20;

//   printf ("Lambda: [%lf,%lf], transient = 2^%d, points = 2^%d\n", lmin, lmax, tr, n);

   tr = (int) pow(2, tr);
   n = (int) pow (2, n);
   facc = pow(10.0,-acc);
   npd = pow(2, npd);

   x[0] = 0.5;
   l = 0.0;

   fptr = fopen("ppdlambdaalpha.dat", "w");

   p = 1;
   flag = 0;
   lmax = 2.0;
   lmin = 0.0;
   dl=(lmax-lmin)/(double)n;

   for (i = 0; i < n && p <= npd; i++) {
      x[0] = ftr(x[0], l, tr);

      for (k = 1; k < p; k++) x[k] = f(x[k-1], l); 

      for (j = 1; j < n / p && !flag; j++) {
         xtmp = f(x[p-1], l);
         if ((fabs(x[0] - xtmp) < facc)) {
            x[0] = xtmp;
            for (k = 1; k < p && !flag; k++) {
               xtmp = f(x[k-1], l);
               if (fabs(x[k] - xtmp) < facc) x[k] = xtmp;
               else flag = 1;
            }
         } else flag = 1;
      }

      if (flag) {
         for (k = 0; k < p; k++) fprintf(fptr, "%.15lf\t%.15lf\n", l-dl/2.0, x[k]);
         if (dl > pow(10.0, -15.0))   dl *= 1.0/4.5;
         if (facc > pow(10.0, -15.0)) facc *= 1.0/2.6;
         p *= 2;
         flag = 0;
         i = 0;
      }
      
      l += dl;
   }

   fclose(fptr);

   fptr = fopen("ppdgnuplot.tmp", "w");
   fprintf(fptr, /*"set terminal postscript\n"
                 "set output \"ppdtmpb.ps\"\n"*/
                 "set title \"Lambda bif & x*s\n"
                 "plot [ ][] \"ppdlambdaalpha.dat\" u 1:2\n"
                 );
   fclose(fptr);

   system("gnuplot -persist < ppdgnuplot.tmp");
//   system("convert -rotate 90 ppdtmpb.ps ppdtmpb.jpg");
//   system("rm ppdgnuplot.tmp;rm ppdtmp.dat;rm ppdtmpa.ps");
}

void parth(void) {
}
